public class FixedLeaderboard implements SimpleList<String> {

    String[] array;
    int allocationSize;
    int size;

    final int DEFAULT_CAPACITY = 10;

    public FixedLeaderboard(int initialCapacity) {
        allocationSize = initialCapacity;
        size = 0;
        array = new String[initialCapacity];
    }
    @Override
    public boolean add(String name) {
        if (size == allocationSize) {
            return false;
        }
        array[size] = name;
        size++;
        return true;
    }

    @Override
    public void add(int index, String name) {
        if (size == allocationSize) {
            return;
        }
        for (int i = size; i > index; i--) {
            array[i] = array[i - 1];
        }
        array[index] = name;
        size++;
    }

    @Override
    public String get(int index) {
        if (index < 0 || index >= size()) {
            throw new IllegalArgumentException("Must have index >= 0 && index < size");
        }
        return array[index];
    }

    @Override
    public String remove(int index) {
        String toRemove = array[index];
        for (int i = index; i < size - 1; i++) {
            array[i] = array[i + 1];
        }
        array[size - 1] = null;
        size--;
        return toRemove;
    }

    @Override
    public boolean remove(Object o) {
        int targetIndex = -1;
        for (int i = 0; i < size; i++) {
            if (array[i].equals(o)) {
                targetIndex = i;
                break;
            }
        }
        if (targetIndex == -1) {
            return false;
        }

        remove(targetIndex);
        return true;
    }

    @Override
    public String set(int i, String elem) {
        return null;
    }

    @Override
    public int size() {
        return size;
    }
}
